package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class AprovacaoCardapioMatrizPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Aprovação do Cardápio pela Matriz']");
    By telaAprovacao = By.xpath("//div[text() = 'Aprovação do Cardápio pela Matriz']");
    By agrupamentoUnidade = By.xpath("//div[@id = 'GRUPFILI']//span[@zh-icon='no-border search']");
    By limpaAgrupamento = By.xpath("//div[@id = 'GRUPFILI']//span[@zh-icon='no-border close-x']");
    By filtroBusca = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By informaBusca = By.xpath("//*[@class = 'mousetrap zh-input-search-floating ng-pristine ng-valid ng-touched']");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By selecionaCusto = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By checkBoxTodasUnidades = By.xpath("//div[@data-zh-id='12742539022422581008454']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoUnidade = By.xpath("//div[@id = 'NMFILIAL']");
    By ckeckBoxUnidade = By.xpath("//div[@id= 'grid-9999']//div[@class = 'th grid-checkbox-column fixed']");
    By btnOk = By.xpath("//div[@id = 'footer']//span[text() = 'Ok']");
    By ckeckBoxTodosServicos = By.xpath("//label[@for = 'zh-checkbox-ALL_CDSERVFILI']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");
    By ckeckBoxServico = By.xpath("//div[@id= 'grid-9999']//div[@class = 'th grid-checkbox-column fixed']");
    By buscaTipoCusto = By.xpath("//div[@id = 'NMTIPOCUSTO']//span[@zh-icon='no-border search']");
    By btnCalendario = By.xpath("//div[@id = 'DTMESCARD']//span[@zh-icon='no-border calendar']");
    By mesCardapioAprovacao = By.xpath("//div[@class= 'month']//div[text() = 'Abr']");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");
    By observacaoGeral = By.xpath("//textarea[@name = 'DSGERAPROCARDMATR']");
    By selecionaServicoAprovacao = By.xpath("//div[@class = 'tr cell1']//div[@class= 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By selecionaServicoAprovar = By.xpath("//div[@class = 'tr cell2']//div[@class= 'td grid-checkbox-column zh-side-column fixed zh-ripple-effect']");
    By selecionaTodosServicosAprovacao = By.xpath("//div[@id = 'grid-12742539021351839340443']//div[@class = 'th grid-checkbox-column fixed']");
    By btnAcoes = By.xpath("//span[text() = 'Ações']");
    By btnAprovarCardapio = By.xpath("//span[text() = 'Aprovar Cardápio']");
    By btnCancelarAprovacao = By.xpath("//span[text() = 'Cancelar Cardápio']");
    By confirmaAprovacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By negaAprovacao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Não']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By btnSalvarObservacao = By.xpath("//span[text() = 'Salvar']");
    By clicarGridTela = By.xpath("//div[@class = 'body-content']");
    By btnOkMensagemAlerta = By.xpath("//button[@class = 'zh-alert-button']//span[text() = 'OK']");
    By limparFiltroRealizado = By.xpath("//div[@class = 'control-info']//*[@id = 'close-x']");
    By abreTelaFiltro = By.xpath("//span[@data-zh-icon='filter no-border icon-white']");
    By clearFiltro = By.xpath("//*[@id='footer']/div[2]/ul/li/a");
    public void acessaTela(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Aprovação do Cardápio pela Matriz");
        tempo();
        click(selecionaTela);
        tempo();
        waitForElement(telaAprovacao);
        tempo();
        
    }

    public void realizarFiltro(){
        click(agrupamentoUnidade);
        tempo();
        click(filtroBusca);
        click(filtroBusca);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0000000002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(campoUnidade);
        tempo();
        click(filtroBusca);
        click(filtroBusca);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"0002");
        tempo();
        click(ckeckBoxUnidade);
        click(btnOk);
        tempo();
        click(campoServico);
        tempo();
        click(ckeckBoxServico);
        click(btnOk);
        tempo();
        click(buscaTipoCusto);
        tempo();
        click(filtroBusca);
        click(filtroBusca);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"Custo Médio Bruto Atual");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnCalendario);
        tempo();
        click(mesCardapioAprovacao);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public void aprovaCardapio(){
        click(selecionaServicoAprovacao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnAprovarCardapio);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
    }

    public void aprovaTodosCardapios(){
        click(selecionaTodosServicosAprovacao);
        tempo();
        click(observacaoGeral);
        clearAndSendKeys(observacaoGeral,"Cardápio aprovado sem ressalvas. Validação da rotina de apro" +
                "vação de Cardápio pela Matriz!");
        tempo();
        click(clicarGridTela);
        tempo();
        click(btnSalvarObservacao);
        tempo();
        click(btnOkMensagemAlerta);
        click(selecionaServicoAprovar);
        click(btnAcoes);
        tempo();
        click(btnAprovarCardapio);
        tempo();
        click(negaAprovacao);
        tempo();
        click(btnCancelar);
        tempo();
        click(selecionaTodosServicosAprovacao);
        click(selecionaTodosServicosAprovacao);
        click(btnAcoes);
        click(btnAprovarCardapio);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnAprovarCardapio);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();

    }

    public void novoFiltro(){
        click(selecionaTodosServicosAprovacao);
        tempo();
        click(abreTelaFiltro);
        tempo();
        click(clearFiltro);
        tempo();
        click(checkBoxTodasUnidades);
        click(ckeckBoxTodosServicos);
        tempo();
        click(buscaTipoCusto);
        tempo();
        click(filtroBusca);
        click(filtroBusca);
        click(informaBusca);
        clearAndSendKeys(informaBusca,"Custo Médio Bruto Atual");
        tempo();
        click(selecionaCusto);
        tempo();
        click(btnCalendario);
        tempo();
        click(mesCardapioAprovacao);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public void cancelaAprovacao(){
        click(observacaoGeral);
        clear(observacaoGeral);
        tempo();
        click(clicarGridTela);
        tempo();
        click(btnSalvarObservacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
        click(selecionaTodosServicosAprovacao);
        tempo();
        click(btnAcoes);
        tempo();
        click(btnCancelarAprovacao);
        tempo();
        click(confirmaAprovacao);
        tempo();
        click(btnOkMensagemAlerta);
        tempo();
    }

}
